## libodsstream 0.7.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

# CMake script for PAPPSOms++ library
# Authors: Olivier Langella & Filippo Rusconi
# Created: 03/03/2015
# Rework: April 2020 (Coronavirus confinement)

############################################################
############################################################
# Basic information about project

set(PROJECT odsstream)
project(${PROJECT} CXX C)

set(LIBODSSTREAM_VERSION_MAJOR "0")
set(LIBODSSTREAM_VERSION_MINOR "7")
set(LIBODSSTREAM_VERSION_PATCH "9")
set(LIBODSSTREAM_LIB_NAME "libodsstream")
set(LIBODSSTREAM_VERSION "${LIBODSSTREAM_VERSION_MAJOR}.${LIBODSSTREAM_VERSION_MINOR}.${LIBODSSTREAM_VERSION_PATCH}")
set(VERSION 0.7.9)
set(LIBODSSTREAM_LIB_VERSION ${LIBODSSTREAM_VERSION})
set(LIBODSSTREAM_LIB_SOVERSION ${LIBODSSTREAM_VERSION_MAJOR})

# Command to enable debug and tests
# cmake -DCMAKE_BUILD_TYPE=Debug  -DMAKE_TEST=1 -DUSEPAPPSOTREE=0 ..

include(GNUInstallDirs)

set(HOME_DEVEL_DIR $ENV{HOME}/devel)
message("\n${BoldRed}The devel directory where all the development projects
should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")

# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)
#message("CMAKE_MODULE_PATH:" ${CMAKE_MODULE_PATH})


# This include must come before all the others
# It must include the config-generated config.h file
# before the others.
#include_directories(${CMAKE_BINARY_DIR})

# And now the source directory contains the .h|.hpp files for its .cpp files.
#include_directories(${CMAKE_SOURCE_DIR})

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN64 if SYSTEM_UNAME_S is "^.*MING64.*"
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

message("\n${BoldRed}Configuring build for project ${PROJECT}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
	execute_process( COMMAND cmake -E copy_if_different
		${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
		${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
		)
endif()


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)
# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall.${ColourReset}")
add_definitions(-Wall)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)
#message(STATUS "${BoldGreen}Setting definition -pedantic.${ColourReset}")
#add_definitions(-pedantic)

if(WARN_AS_ERROR)
	message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
	add_definitions(-Werror)
endif()

message(STATUS "${BoldRed}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(MXE)

	# Run the following cmake command line:
	# x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
	include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
	#include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)

	# Set the name to the systemUname variable because in this situation that name
	# is not found, it it passed as a flag in the command line.
	set(SYSTEM_UNAME_S "mxe")

elseif(UNIX AND NOT APPLE)

	# Run the following cmake command line:
	# cmake -DCMAKE_BUILD_TYPE=Debug

	include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

elseif(WIN32 OR _WIN32)

	# Run the following cmake command line:
	# cmake -DCMAKE_BUILD_TYPE=Release ../development

	include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)

elseif(APPLE)

	# Run the following cmake command line:
	# cmake -DCMAKE_BUILD_TYPE=Release ../development

	include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${PROJECT}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE Release CACHE STRING
		"Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
		FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
	message(STATUS "Compiling in release mode.")
	add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
	message(STATUS "Compiling in debug mode with MAKE_TEST: ${MAKE_TEST}.")
	message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
	add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
	message(STATUS "Compiling in release with debug info mode.")
endif(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")



set(CPACK_CMAKE_GENERATOR "Unix Makefiles")
set(CPACK_GENERATOR "STGZ;TGZ;TZ")
set(CPACK_OUTPUT_CONFIG_FILE "./CPackConfig.cmake")
#set(CPACK_PACKAGE_DESCRIPTION_FILE ${LIBODSSTREAM_SOURCE_DIR}/COPYING)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "library to read and write ODS files using streams")
set(CPACK_PACKAGE_EXECUTABLES "libodsstream")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "libodsstream-${LIBODSSTREAM_VERSION}")
set(CPACK_SYSTEM_NAME "Linux-i686")
set(CPACK_PACKAGE_FILE_NAME "libodsstream-${LIBODSSTREAM_VERSION}-${CPACK_SYSTEM_NAME}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "libodsstream ${LIBODSSTREAM_VERSION}")
set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "libodsstream ${LIBODSSTREAM_VERSION}")
set(CPACK_PACKAGE_NAME "libodsstream")
set(CPACK_PACKAGE_VENDOR "PAPPSO")
set(CPACK_PACKAGE_VERSION ${LIBODSSTREAM_VERSION})
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/debian/copyright)
set(CPACK_RESOURCE_FILE_README ${CMAKE_SOURCE_DIR}/README)
set(CPACK_RESOURCE_FILE_WELCOME ${CMAKE_SOURCE_DIR}/README)
set(CPACK_SOURCE_GENERATOR "TGZ;TZ")
set(CPACK_SOURCE_OUTPUT_CONFIG_FILE "./CPackSourceConfig.cmake")
set(CPACK_SOURCE_STRIP_FILES "")
set(CPACK_SYSTEM_NAME "Linux-i686")
set(CPACK_TOPLEVEL_TAG "Linux-i686")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "libodsstream-${LIBODSSTREAM_VERSION}")


set(CPACK_SOURCE_IGNORE_FILES 
	".*\\\\.tar\\\\.gz"
	"moc_.*cxx"
	"\\\\.#.*"
	".*\\\\.aux"
	".*\\\\.bbl"
	".*\\\\.blg"
	".*\\\\.log"
	".*\\\\.out"
	".*\\\\.toc"
	"/devel_archives/"
	"/doc\\\\/html/"
	"/doc\\\\/latex/"
	"Makefile"
	"install_manifest.txt"
	"CMakeCache.txt"
	"CPackConfig.cmake"
	"CPackSourceConfig.cmake"
	"/CMakeFiles/"
	"/_CPack_Packages/"
	"/Debug/"
	"/Release/"
	"/tests/"
	"/\\\\.externalToolBuilders/"
	"/\\\\.git/"
	"/\\\\.kdev4/"
	"/\\\\.settings/"
	"Makefile"
	"\\\\.gitignore"
	"\\\\.cdtbuild"
	"\\\\.cdtproject"
	"\\\\.project"
	"\\\\.cproject"
	"/win32/"
	"/win64/"
	"/build/"
	"/buildwin64/"
	"/cbuild/"
	"/wbuild/"
	"/bin/"
	"/buildmingw/"
	"test\\\\.ods"
	"buildwin32.cmd"
	"libodsstream.so"
	"OpenDocument-v1.0-os.pdf"
	)
# to create a TGZ archive of the  source code type shell command
# cpack -G TGZ --config CPackSourceConfig.cmake 

# dpkg-buildpackage -rfakeroot -k7BEF3B25

#.dput.cf
#[olivier-langella]
#fqdn = ppa.launchpad.net
#method = ftp
#incoming = ~olivier-langella/ubuntu/
#login = olivier-langella
#allow_unsigned_uploads = 0
#
#  debuild -S -sa
# dput -f olivier-langella *changes


#dch -Dstretch "message"
#cmake ..
#make deb
# scp libodsstream* proteus:/var/www/apt/incoming
# scp ods2tsv* proteus:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default


#dpkg-deb -x libodsstream-qt4_0.3.0-3_amd64.deb libodsstream-qt4_0.3.0-3
#dpkg-gensymbols -v0 -plibodsstream-qt4 -Plibodsstream-qt4_0.3.0-3 -Osymbols
#cp symbols ../debian/libodsstream-qt4.symbols
#dpkg-deb -x libodsstream-qt5_0.3.0-3_amd64.deb libodsstream-qt5_0.3.0-3
#dpkg-gensymbols -v0 -plibodsstream-qt5 -Plibodsstream-qt5_0.3.0-3 -Osymbols
#cp symbols ../debian/libodsstream-qt5.symbols

#MESSAGE("configuring file ${LIBODSSTREAM_SOURCE_DIR}/src/config.h.cmake")

#configure_file (${LIBODSSTREAM_SOURCE_DIR}/src/config.h.cmake ${LIBODSSTREAM_SOURCE_DIR}/src/config.h)



set(CPACK_PACKAGE_EXECUTABLES "libodsstream" "libodsstream")


# for debian package :
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Olivier Langella <olivier.langella@u-psud.fr>")
set(DEBIAN_PACKAGE_BUILDS_DEPENDS "Olivier Langella <olivier.langella@u-psud.fr>")


include(CPack)

add_subdirectory (src)

add_subdirectory (doc)

add_custom_target(targz
	cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz libodsstream-${LIBODSSTREAM_VERSION}.tar.gz
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "Creating .tar.gz" VERBATIM
	)


add_custom_target(deb
	ln -s libodsstream-${LIBODSSTREAM_VERSION}.tar.gz libodsstream_${LIBODSSTREAM_VERSION}.orig.tar.gz && cd libodsstream-${LIBODSSTREAM_VERSION} && dpkg-buildpackage -sa
	DEPENDS targz
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "Creating Debian package" VERBATIM
	)

add_custom_target(lintian
	lintian -IEi --pedantic ${changesdeb}
	DEPENDS deb
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "lintian check" VERBATIM
	)

if(MAKE_TEST)
	enable_testing()
	include(CTest)
	if(BUILD_TESTING)
		add_subdirectory(test)
	endif(BUILD_TESTING)
endif(MAKE_TEST)


# message(STATUS CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH})

# Install cmake module
install(FILES ${CMAKE_MODULE_PATH}/FindOdsStream.cmake DESTINATION share/cmake/Modules)
# Install cmake config
configure_file (${CMAKE_MODULE_PATH}/OdsStreamConfig.cmake ${CMAKE_SOURCE_DIR}/OdsStreamConfig.cmake)
install(FILES ${CMAKE_SOURCE_DIR}/OdsStreamConfig.cmake DESTINATION lib${LIB_SUFFIX}/cmake/odsstream)
#configure_file (${CMAKE_SOURCE_DIR}/debian/rules.cmake ${CMAKE_SOURCE_DIR}/debian/rules @ONLY)

=== debian/changelog ===
libodsstream (0.7.9-1) unstable; urgency=low

  * New upstream version that fixes bug on 32-bit platforms (Closes: #959539).

  * Improvements to the packaging with use of dh-exec for the d/links files.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 18 Jun 2020 15:10:11 +0200

libodsstream (0.7.8-4) buster; urgency=medium

  * fix for Debian Bug report logs - #959539

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 15 Jun 2020 08:21:19 +0200

libodsstream (0.7.8-3) buster; urgency=medium

  * buster port

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 18 May 2020 10:03:21 +0200

libodsstream (0.7.8-2) unstable; urgency=low

  * Merge in the modifications from Andreas Tille (thank you!)

  [ Andreas Tille ]
  * debhelper-compat 12 (routine-update)
  * cme fix dpkg-control
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 05 May 2020 18:33:18 +0200

libodsstream (0.7.8-1) unstable; urgency=low

  * Conversion of all the files to UNIX format (some had a DOS format);

  * Removal of all the warnings generated by GCC (mainly using the
    [[maybe_unused]] directive).

  * Ensure that the naming of the lib in the CMake dialect is according to the
    scheme: OdsStream and not ODSSTREAM...

  * Ensure that gbp import-orig is used to store the upstream tarball in the
    git repos (closes: #959637). Warm thanks to Andras Tille for spotting the
    problem and reporting it <andreas@an3as.eu>.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 30 Apr 2020 16:19:46 +0200

libodsstream (0.7.7-1) unstable; urgency=low

  * New upstream version with a fix for the libquazip5-finding
    CMake module.

  * Automated the version numbering in the d/*.install files with
    CMake config files.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 27 Apr 2020 10:18:22 +0200

libodsstream (0.7.6-1) unstable; urgency=low

  * New upstream starting the implementation of MultiArch in
    the CMake build system.

  * Fixes to the packaging with respect to MultiArch.

  * Introduce an unversioned Conflict: for package replacement as
    it seemed to be needed.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 23 Apr 2020 21:37:40 +0200

libodsstream (0.7.5-1) unstable; urgency=low

  * New upstream version.

  * Small fixes to the Debian packaging bits.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 21 Apr 2020 14:57:06 +0200

libodsstream (0.7.4-2) buster; urgency=medium

  * merge with mia repository

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 08 Apr 2020 18:39:45 +0200

libodsstream (0.7.4-1) buster; urgency=medium

  * new tests for better reliability
  * modern exception handler

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 08 Apr 2020 18:30:56 +0200

libodsstream (0.7.3-3ubuntu1) bionic; urgency=medium

  * bionic beaver version

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 10 Jan 2020 17:56:30 +0000

libodsstream (0.7.3-3) buster; urgency=medium

  * better cmake config

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 19 Dec 2019 21:45:51 +0100

libodsstream (0.7.3-2) buster; urgency=medium

  * write std::size_t, new cmake targets

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 19 Dec 2019 21:14:59 +0100

libodsstream (0.7.3-1) buster; urgency=medium

  * new cmake syntax, slight API changes

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 13 Nov 2019 16:41:32 +0100

libodsstream (0.7.2-3) buster; urgency=medium

  * buster package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 12 Sep 2019 15:49:35 +0200

libodsstream (0.7.2-1) buster; urgency=medium

  * first buster package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 05 Aug 2019 13:02:35 +0200

=== debian/control ===
Source: libodsstream
Maintainer: The Debichem Group <debichem-devel@alioth-lists.debian.net>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat(= 12),
 dh-exec (>= 0.3),
 cmake,
 d-shlibs,
 libquazip5-dev,
 qtbase5-dev,
 doxygen
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/debichem-team/libodsstream
Vcs-Git: https://salsa.debian.org/debichem-team/libodsstream.git
Homepage: http://pappso.inrae.fr/bioinfo
Rules-Requires-Root: no

Package: libodsstream-qt5-0
Architecture: all
Section: oldlibs
Depends: libodsstream0,
         ${misc:Depends}
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: libodsstream0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libodsstream-qt5-0 (<< 0.7.9-1~)
Replaces: libodsstream-qt5-0 (<< 0.7.9-1~)
Description: C++ library to read or write ODS files
 libodsstream provides a simple way to read and write Open
 Document Spreadsheet files. The hight memory efficiency comes
 from the fact that only streams are used for the read/write
 operations.
 .
 This package contains the shared library.

Package: libodsstream-qt5-dev
Architecture: all
Section: oldlibs
Depends: libodsstream-dev,
         ${misc:Depends}
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: libodsstream-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libodsstream0 (= ${binary:Version}),
         ${misc:Depends},
         libquazip5-dev
Breaks: libodsstream-qt5-dev (<< 0.7.9-1~)
Replaces: libodsstream-qt5-dev (<< 0.7.9-1~)
Description: C++ library to read or write ODS files (development files)
 libodsstream provides a simple way to read and write Open
 Document Spreadsheet files. The hight memory efficiency comes
 from the fact that only streams are used for the read/write
 operations.
 .
 This package contains the header files of the library.

Package: libodsstream-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: doxygen documentation of the ODSstream library
 libodsstream provides a simple way to read and write Open
 Document Spreadsheet files. The hight memory efficiency comes
 from the fact that only streams are used for the read/write
 operations.
 .
 This package contains the developer documentation.

Package: ods2tsv
Architecture: any
Section: text
Depends: ${shlibs:Depends},
         libodsstream0 (= ${binary:Version}),
         ${misc:Depends}
Description: ODS to TSV file converter
 Simple command line interface utility that takes one or more ods
 files as input and convert them into tabulated separated value
 (tsv simple text files).  Each ods file will create an output
 directory of the same name, containing all the spreadsheets
 (one tsv file per spreadsheet).

## libodsstream 0.7.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,10 +14,10 @@
 
 set(LIBODSSTREAM_VERSION_MAJOR "0")
 set(LIBODSSTREAM_VERSION_MINOR "7")
-set(LIBODSSTREAM_VERSION_PATCH "9")
+set(LIBODSSTREAM_VERSION_PATCH "10")
 set(LIBODSSTREAM_LIB_NAME "libodsstream")
 set(LIBODSSTREAM_VERSION "${LIBODSSTREAM_VERSION_MAJOR}.${LIBODSSTREAM_VERSION_MINOR}.${LIBODSSTREAM_VERSION_PATCH}")
-set(VERSION 0.7.9)
+set(VERSION 0.7.10)
 set(LIBODSSTREAM_LIB_VERSION ${LIBODSSTREAM_VERSION})
 set(LIBODSSTREAM_LIB_SOVERSION ${LIBODSSTREAM_VERSION_MAJOR})
 
@@ -105,8 +105,8 @@
 
 	# Run the following cmake command line:
 	# x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
-	include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
-	#include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)
+	#include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
+	include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)
 
 	# Set the name to the systemUname variable because in this situation that name
 	# is not found, it it passed as a flag in the command line.

## libodsstream 0.7.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,10 +14,10 @@
 
 set(LIBODSSTREAM_VERSION_MAJOR "0")
 set(LIBODSSTREAM_VERSION_MINOR "7")
-set(LIBODSSTREAM_VERSION_PATCH "10")
+set(LIBODSSTREAM_VERSION_PATCH "11")
 set(LIBODSSTREAM_LIB_NAME "libodsstream")
 set(LIBODSSTREAM_VERSION "${LIBODSSTREAM_VERSION_MAJOR}.${LIBODSSTREAM_VERSION_MINOR}.${LIBODSSTREAM_VERSION_PATCH}")
-set(VERSION 0.7.10)
+set(VERSION 0.7.11)
 set(LIBODSSTREAM_LIB_VERSION ${LIBODSSTREAM_VERSION})
 set(LIBODSSTREAM_LIB_SOVERSION ${LIBODSSTREAM_VERSION_MAJOR})

=== src/CMakeLists.txt ===
configure_file (${CMAKE_SOURCE_DIR}/src/odsstream/config.h.cmake ${CMAKE_SOURCE_DIR}/src/odsstream/config.h)


set(CPP_FILES 
	odsstream/reader/odscell.cpp
	odsstream/odsexception.h 
	odsstream/saxreader/saxhandlercontentxml.cpp 
	odsstream/odsdocreader.cpp
	odsstream/writer/options/odscolorscale.cpp
	odsstream/writer/options/odstablecellstyle.cpp
	odsstream/writer/options/odstablecellstyleref.cpp
	odsstream/writer/options/odstablesettings.cpp
	odsstream/writer/structure/stylesxml.cpp
	odsstream/writer/structure/contentxml.cpp
	odsstream/writer/structure/metaxml.cpp
	odsstream/writer/structure/settingsxml.cpp
	odsstream/writer/structure/manifestxml.cpp
	odsstream/odsdocwriter.cpp
	odsstream/qtablewriter.cpp
	odsstream/tsvdirectorywriter.cpp
	odsstream/tsvoutputstream.cpp
	odsstream/tsvreader.cpp
	)



set(ODS2CSV_CPP_FILES 
	ods2csv.cpp
	)

set(TSV2ODS_CPP_FILES 
	tsv2ods.cpp
	)



configure_file (${CMAKE_SOURCE_DIR}/src/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)

message ("LIBODSSTREAM_LIB_SOVERSION: ${LIBODSSTREAM_LIB_SOVERSION}")
#qt5-default qtbase5-dev
find_package( Qt5Core REQUIRED )
find_package( Qt5Xml REQUIRED )
find_package( Qt5Gui REQUIRED )

# Build the static lib
add_library(odsstream-static STATIC ${CPP_FILES})

target_include_directories (odsstream-static PUBLIC 
	${QUAZIP_INCLUDE_DIR}
	)

set_target_properties(odsstream-static
	PROPERTIES OUTPUT_NAME odsstream
	CLEAN_DIRECT_OUTPUT 1
	)

target_link_libraries(odsstream-static
	Qt5::Core
	Qt5::Xml
	Qt5::Gui
	ZLIB::ZLIB
	${QUAZIP_LIBRARIES}
	)

# Build the shared lib
add_library(odsstream-shared SHARED ${CPP_FILES})

target_include_directories (odsstream-shared PUBLIC 
	${QUAZIP_INCLUDE_DIR}
	)

set_target_properties(odsstream-shared PROPERTIES
	OUTPUT_NAME odsstream
	VERSION ${LIBODSSTREAM_LIB_VERSION}
	SOVERSION ${LIBODSSTREAM_LIB_SOVERSION}
	)


target_link_libraries(odsstream-shared
	Qt5::Core
	Qt5::Xml
	Qt5::Gui
	ZLIB::ZLIB
	${QUAZIP_LIBRARIES}
	)


# Install libs

install(TARGETS odsstream-shared 
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	# This one is for WIN32
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	)

#if (WIN32 OR _WIN32)
	#install(TARGETS odsstream-shared RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
#else ()
	#install(TARGETS odsstream-shared LIBRARY DESTINATION  ${CMAKE_INSTALL_LIBDIR})
#endif()

install(TARGETS odsstream-static 
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

add_executable(ods2csv ${ODS2CSV_CPP_FILES})

target_include_directories (ods2csv PUBLIC
	"${CMAKE_SOURCE_DIR}/src"
	)

set_target_properties(ods2csv
	PROPERTIES OUTPUT_NAME ods2tsv
	CLEAN_DIRECT_OUTPUT 1
	)

target_link_libraries(ods2csv odsstream-shared
	Qt5::Core
	)

install(PROGRAMS ${CMAKE_BINARY_DIR}/src/ods2tsv DESTINATION bin)


add_executable(tsv2ods ${TSV2ODS_CPP_FILES})

target_include_directories (tsv2ods PUBLIC
	"${CMAKE_SOURCE_DIR}/src"
	)

set_target_properties(tsv2ods
	PROPERTIES OUTPUT_NAME tsv2ods
	CLEAN_DIRECT_OUTPUT 1
	)


target_link_libraries(tsv2ods odsstream-shared
	Qt5::Core
	)

install(PROGRAMS ${CMAKE_BINARY_DIR}/src/tsv2ods DESTINATION bin)


# Install headers
install(DIRECTORY odsstream/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/odsstream 
	FILES_MATCHING PATTERN "*.h"
	PATTERN "*.hpp")

=== test/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015 from the CMakeLists file of the Bio++ project

#CTEST_OUTPUT_ON_FAILURE=TRUE make test
#make test ARGS="-V"

configure_file (config.h.cmake ${CMAKE_SOURCE_DIR}/test/config.h)


find_package(Qt5 COMPONENTS Core Xml Gui REQUIRED)

include_directories(${QUAZIP_INCLUDE_DIR} "${CMAKE_SOURCE_DIR}/src")

add_executable(test_ods test_ods.cpp)
target_link_libraries(test_ods Qt5::Core Qt5::Gui ${QUAZIP_LIBRARIES} odsstream-shared)
add_test(test_ods "test_ods")


add_executable(test_tsv test_tsv.cpp)
target_link_libraries(test_tsv Qt5::Core Qt5::Gui odsstream-shared ${QUAZIP_LIBRARIES})
add_test(test_tsv "test_tsv")


add_executable(test_zlib test_zlib.cpp)
target_link_libraries(test_zlib Qt5::Core odsstream-shared ${QUAZIP_LIBRARIES})
add_test(test_zlib "test_zlib")


if(UNIX)
	set_property(TEST test_ods test_tsv test_zlib ${TEST_LIST} PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
endif()

if(WIN32 OR _WIN32)
	set(ENV{PATH} "$ENV{PATH};..\\src")
endif()

=== debian/changelog ===
libodsstream (0.7.11-1) unstable; urgency=low

  * New upstream release.

  * d/control: Remove section for libodsstream0 that duplicates source's
    section.

  * d/control: Remove the -qt5-named transitional packages.

  * d/control: Remove Langella from uploaders field.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 05 Jan 2021 11:27:07 +0100

libodsstream (0.7.10-1~buster+1) buster; urgency=medium

  * better tsv API to use flush on output streams

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 16 Dec 2020 11:37:28 +0100

=== debian/control ===
--- 
+++ 
@@ -9,25 +9,17 @@
  d-shlibs,
  libquazip5-dev,
  qtbase5-dev,
- doxygen
+ doxygen,
+ catch2
 Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debichem-team/libodsstream
 Vcs-Git: https://salsa.debian.org/debichem-team/libodsstream.git
 Homepage: http://pappso.inrae.fr/bioinfo
 Rules-Requires-Root: no
 
-Package: libodsstream-qt5-0
-Architecture: all
-Section: oldlibs
-Depends: libodsstream0,
-         ${misc:Depends}
-Description: transitional package
- This is a transitional package. It can safely be removed.
-
 Package: libodsstream0
 Architecture: any
 Multi-Arch: same
-Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Breaks: libodsstream-qt5-0 (<< 0.7.9-1~)
@@ -39,14 +31,6 @@
  operations.
  .
  This package contains the shared library.
-
-Package: libodsstream-qt5-dev
-Architecture: all
-Section: oldlibs
-Depends: libodsstream-dev,
-         ${misc:Depends}
-Description: transitional package
- This is a transitional package. It can safely be removed.
 
 Package: libodsstream-dev
 Architecture: any

=== debian/rules ===
#! /usr/bin/make -f
# -*- makefile -*-

# Include for DEB_VERSION_UPSTREAM below
include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)


export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# For automating the d/*.links stuff.
export LIBODSSTREAM_VERSION=$(DEB_VERSION_UPSTREAM)
export LIBODSSTREAM_SOVERSION=0


%:
	dh $@ --buildsystem=cmake


override_dh_clean:
	dh_clean


override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release \
		-DMAKE_TEST=1 \
		-DCMAKE_SKIP_RPATH=1


override_dh_auto_build:
	dh_auto_build --no-parallel
	dh_auto_build -- doc

## libodsstream 0.8.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,11 +13,11 @@
 project(${PROJECT} CXX C)
 
 set(LIBODSSTREAM_VERSION_MAJOR "0")
-set(LIBODSSTREAM_VERSION_MINOR "7")
-set(LIBODSSTREAM_VERSION_PATCH "11")
+set(LIBODSSTREAM_VERSION_MINOR "8")
+set(LIBODSSTREAM_VERSION_PATCH "2")
 set(LIBODSSTREAM_LIB_NAME "libodsstream")
 set(LIBODSSTREAM_VERSION "${LIBODSSTREAM_VERSION_MAJOR}.${LIBODSSTREAM_VERSION_MINOR}.${LIBODSSTREAM_VERSION_PATCH}")
-set(VERSION 0.7.11)
+set(VERSION 0.8.2)
 set(LIBODSSTREAM_LIB_VERSION ${LIBODSSTREAM_VERSION})
 set(LIBODSSTREAM_LIB_SOVERSION ${LIBODSSTREAM_VERSION_MAJOR})
 
@@ -106,7 +106,7 @@
 	# Run the following cmake command line:
 	# x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
 	#include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
-	include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)
+	include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
 
 	# Set the name to the systemUname variable because in this situation that name
 	# is not found, it it passed as a flag in the command line.

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 set(CPP_FILES 
 	odsstream/reader/odscell.cpp
 	odsstream/odsexception.h 
-	odsstream/saxreader/saxhandlercontentxml.cpp 
+	odsstream/saxreader/qxmlstreamreadercontentxml.cpp
 	odsstream/odsdocreader.cpp
 	odsstream/writer/options/odscolorscale.cpp
 	odsstream/writer/options/odstablecellstyle.cpp
@@ -20,6 +20,7 @@
 	odsstream/tsvdirectorywriter.cpp
 	odsstream/tsvoutputstream.cpp
 	odsstream/tsvreader.cpp
+	odsstream/ziptsvoutputstream.cpp
 	)
 
 
@@ -37,10 +38,8 @@
 configure_file (${CMAKE_SOURCE_DIR}/src/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)
 
 message ("LIBODSSTREAM_LIB_SOVERSION: ${LIBODSSTREAM_LIB_SOVERSION}")
-#qt5-default qtbase5-dev
-find_package( Qt5Core REQUIRED )
-find_package( Qt5Xml REQUIRED )
-find_package( Qt5Gui REQUIRED )
+
+find_package(Qt5 COMPONENTS Gui Xml REQUIRED)
 
 # Build the static lib
 add_library(odsstream-static STATIC ${CPP_FILES})
@@ -55,7 +54,6 @@
 	)
 
 target_link_libraries(odsstream-static
-	Qt5::Core
 	Qt5::Xml
 	Qt5::Gui
 	ZLIB::ZLIB
@@ -77,7 +75,6 @@
 
 
 target_link_libraries(odsstream-shared
-	Qt5::Core
 	Qt5::Xml
 	Qt5::Gui
 	ZLIB::ZLIB

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -10,10 +10,12 @@
 
 find_package(Qt5 COMPONENTS Core Xml Gui REQUIRED)
 
+find_package(Catch2 REQUIRED)
+
 include_directories(${QUAZIP_INCLUDE_DIR} "${CMAKE_SOURCE_DIR}/src")
 
 add_executable(test_ods test_ods.cpp)
-target_link_libraries(test_ods Qt5::Core Qt5::Gui ${QUAZIP_LIBRARIES} odsstream-shared)
+target_link_libraries(test_ods Catch2::Catch2 Qt5::Core Qt5::Gui ${QUAZIP_LIBRARIES} odsstream-shared)
 add_test(test_ods "test_ods")

=== debian/changelog ===
libodsstream (0.8.2-1) unstable; urgency=low

  * Debian packaging: fix the erroneous distribution (see stanza below).

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 11 Jul 2022 11:12:31 +0200

libodsstream (0.8.1-1) bullseye; urgency=low

  * Debian packaging.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 01 Jul 2022 10:06:37 +0200

libodsstream (0.8.0-1) bullseye; urgency=medium

  * fix for integer writing in TSV output
  * new Zipped file tsv output ZipTsvOutputStream

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 28 Jun 2022 11:06:54 +0200

## libodsstream 0.8.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,10 +14,10 @@
 
 set(LIBODSSTREAM_VERSION_MAJOR "0")
 set(LIBODSSTREAM_VERSION_MINOR "8")
-set(LIBODSSTREAM_VERSION_PATCH "2")
+set(LIBODSSTREAM_VERSION_PATCH "7")
 set(LIBODSSTREAM_LIB_NAME "libodsstream")
 set(LIBODSSTREAM_VERSION "${LIBODSSTREAM_VERSION_MAJOR}.${LIBODSSTREAM_VERSION_MINOR}.${LIBODSSTREAM_VERSION_PATCH}")
-set(VERSION 0.8.2)
+set(VERSION 0.8.7)
 set(LIBODSSTREAM_LIB_VERSION ${LIBODSSTREAM_VERSION})
 set(LIBODSSTREAM_LIB_SOVERSION ${LIBODSSTREAM_VERSION_MAJOR})
 
@@ -106,7 +106,7 @@
 	# Run the following cmake command line:
 	# x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
 	#include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
-	include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
+	include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)
 
 	# Set the name to the systemUname variable because in this situation that name
 	# is not found, it it passed as a flag in the command line.

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -45,7 +45,7 @@
 add_library(odsstream-static STATIC ${CPP_FILES})
 
 target_include_directories (odsstream-static PUBLIC 
-	${QUAZIP_INCLUDE_DIR}
+  QuaZip::QuaZip
 	)
 
 set_target_properties(odsstream-static
@@ -57,14 +57,14 @@
 	Qt5::Xml
 	Qt5::Gui
 	ZLIB::ZLIB
-	${QUAZIP_LIBRARIES}
+  QuaZip::QuaZip
 	)
 
 # Build the shared lib
 add_library(odsstream-shared SHARED ${CPP_FILES})
 
 target_include_directories (odsstream-shared PUBLIC 
-	${QUAZIP_INCLUDE_DIR}
+  QuaZip::QuaZip
 	)
 
 set_target_properties(odsstream-shared PROPERTIES
@@ -78,7 +78,7 @@
 	Qt5::Xml
 	Qt5::Gui
 	ZLIB::ZLIB
-	${QUAZIP_LIBRARIES}
+  QuaZip::QuaZip
 	)

## libodsstream 0.9.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,11 +13,11 @@
 project(${PROJECT} CXX C)
 
 set(LIBODSSTREAM_VERSION_MAJOR "0")
-set(LIBODSSTREAM_VERSION_MINOR "8")
-set(LIBODSSTREAM_VERSION_PATCH "7")
+set(LIBODSSTREAM_VERSION_MINOR "9")
+set(LIBODSSTREAM_VERSION_PATCH "1")
 set(LIBODSSTREAM_LIB_NAME "libodsstream")
 set(LIBODSSTREAM_VERSION "${LIBODSSTREAM_VERSION_MAJOR}.${LIBODSSTREAM_VERSION_MINOR}.${LIBODSSTREAM_VERSION_PATCH}")
-set(VERSION 0.8.7)
+set(VERSION 0.9.1)
 set(LIBODSSTREAM_LIB_VERSION ${LIBODSSTREAM_VERSION})
 set(LIBODSSTREAM_LIB_SOVERSION ${LIBODSSTREAM_VERSION_MAJOR})
 
@@ -66,10 +66,10 @@
 set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
 
 if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
-	execute_process( COMMAND cmake -E copy_if_different
-		${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
-		${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
-		)
+  execute_process( COMMAND cmake -E copy_if_different
+    ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
+    ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
+  )
 endif()
 
 
@@ -91,8 +91,8 @@
 #add_definitions(-pedantic)
 
 if(WARN_AS_ERROR)
-	message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
-	add_definitions(-Werror)
+  message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
+  add_definitions(-Werror)
 endif()
 
 message(STATUS "${BoldRed}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")
@@ -103,35 +103,35 @@
 # Platform-specific CMake configuration
 if(MXE)
 
-	# Run the following cmake command line:
-	# x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
-	#include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
-	include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)
-
-	# Set the name to the systemUname variable because in this situation that name
-	# is not found, it it passed as a flag in the command line.
-	set(SYSTEM_UNAME_S "mxe")
+  # Run the following cmake command line:
+  # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
+  #include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
+  include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)
+
+  # Set the name to the systemUname variable because in this situation that name
+  # is not found, it it passed as a flag in the command line.
+  set(SYSTEM_UNAME_S "mxe")
 
 elseif(UNIX AND NOT APPLE)
 
-	# Run the following cmake command line:
-	# cmake -DCMAKE_BUILD_TYPE=Debug
-
-	include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)
+  # Run the following cmake command line:
+  # cmake -DCMAKE_BUILD_TYPE=Debug
+
+  include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)
 
 elseif(WIN32 OR _WIN32)
 
-	# Run the following cmake command line:
-	# cmake -DCMAKE_BUILD_TYPE=Release ../development
-
-	include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
+  # Run the following cmake command line:
+  # cmake -DCMAKE_BUILD_TYPE=Release ../development
+
+  include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
 
 elseif(APPLE)
 
-	# Run the following cmake command line:
-	# cmake -DCMAKE_BUILD_TYPE=Release ../development
-
-	include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)
+  # Run the following cmake command line:
+  # cmake -DCMAKE_BUILD_TYPE=Release ../development
+
+  include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)
 
 endif()
 
@@ -148,24 +148,24 @@
 message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})
 
 if(NOT CMAKE_BUILD_TYPE)
-	set(CMAKE_BUILD_TYPE Release CACHE STRING
-		"Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
-		FORCE)
+  set(CMAKE_BUILD_TYPE Release CACHE STRING
+    "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
+    FORCE)
 endif(NOT CMAKE_BUILD_TYPE)
 
 if(CMAKE_BUILD_TYPE MATCHES "Release")
-	message(STATUS "Compiling in release mode.")
-	add_definitions("-DQT_NO_DEBUG_OUTPUT")
+  message(STATUS "Compiling in release mode.")
+  add_definitions("-DQT_NO_DEBUG_OUTPUT")
 endif()
 
 if(CMAKE_BUILD_TYPE MATCHES "Debug")
-	message(STATUS "Compiling in debug mode with MAKE_TEST: ${MAKE_TEST}.")
-	message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
-	add_definitions(-ggdb3)
+  message(STATUS "Compiling in debug mode with MAKE_TEST: ${MAKE_TEST}.")
+  message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
+  add_definitions(-ggdb3)
 endif()
 
 if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
-	message(STATUS "Compiling in release with debug info mode.")
+  message(STATUS "Compiling in release with debug info mode.")
 endif(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
 
 message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")
@@ -198,51 +198,51 @@
 
 
 set(CPACK_SOURCE_IGNORE_FILES 
-	".*\\\\.tar\\\\.gz"
-	"moc_.*cxx"
-	"\\\\.#.*"
-	".*\\\\.aux"
-	".*\\\\.bbl"
-	".*\\\\.blg"
-	".*\\\\.log"
-	".*\\\\.out"
-	".*\\\\.toc"
-	"/devel_archives/"
-	"/doc\\\\/html/"
-	"/doc\\\\/latex/"
-	"Makefile"
-	"install_manifest.txt"
-	"CMakeCache.txt"
-	"CPackConfig.cmake"
-	"CPackSourceConfig.cmake"
-	"/CMakeFiles/"
-	"/_CPack_Packages/"
-	"/Debug/"
-	"/Release/"
-	"/tests/"
-	"/\\\\.externalToolBuilders/"
-	"/\\\\.git/"
-	"/\\\\.kdev4/"
-	"/\\\\.settings/"
-	"Makefile"
-	"\\\\.gitignore"
-	"\\\\.cdtbuild"
-	"\\\\.cdtproject"
-	"\\\\.project"
-	"\\\\.cproject"
-	"/win32/"
-	"/win64/"
-	"/build/"
-	"/buildwin64/"
-	"/cbuild/"
-	"/wbuild/"
-	"/bin/"
-	"/buildmingw/"
-	"test\\\\.ods"
-	"buildwin32.cmd"
-	"libodsstream.so"
-	"OpenDocument-v1.0-os.pdf"
-	)
+  ".*\\\\.tar\\\\.gz"
+  "moc_.*cxx"
+  "\\\\.#.*"
+  ".*\\\\.aux"
+  ".*\\\\.bbl"
+  ".*\\\\.blg"
+  ".*\\\\.log"
+  ".*\\\\.out"
+  ".*\\\\.toc"
+  "/devel_archives/"
+  "/doc\\\\/html/"
+  "/doc\\\\/latex/"
+  "Makefile"
+  "install_manifest.txt"
+  "CMakeCache.txt"
+  "CPackConfig.cmake"
+  "CPackSourceConfig.cmake"
+  "/CMakeFiles/"
+  "/_CPack_Packages/"
+  "/Debug/"
+  "/Release/"
+  "/tests/"
+  "/\\\\.externalToolBuilders/"
+  "/\\\\.git/"
+  "/\\\\.kdev4/"
+  "/\\\\.settings/"
+  "Makefile"
+  "\\\\.gitignore"
+  "\\\\.cdtbuild"
+  "\\\\.cdtproject"
+  "\\\\.project"
+  "\\\\.cproject"
+  "/win32/"
+  "/win64/"
+  "/build/"
+  "/buildwin64/"
+  "/cbuild/"
+  "/wbuild/"
+  "/bin/"
+  "/buildmingw/"
+  "test\\\\.ods"
+  "buildwin32.cmd"
+  "libodsstream.so"
+  "OpenDocument-v1.0-os.pdf"
+)
 # to create a TGZ archive of the  source code type shell command
 # cpack -G TGZ --config CPackSourceConfig.cmake 
 
@@ -296,40 +296,61 @@
 add_subdirectory (doc)
 
 add_custom_target(targz
-	cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz libodsstream-${LIBODSSTREAM_VERSION}.tar.gz
-	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
-	COMMENT "Creating .tar.gz" VERBATIM
-	)
+  cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz libodsstream-${LIBODSSTREAM_VERSION}.tar.gz
+  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+  COMMENT "Creating .tar.gz" VERBATIM
+)
 
 
 add_custom_target(deb
-	ln -s libodsstream-${LIBODSSTREAM_VERSION}.tar.gz libodsstream_${LIBODSSTREAM_VERSION}.orig.tar.gz && cd libodsstream-${LIBODSSTREAM_VERSION} && dpkg-buildpackage -sa
-	DEPENDS targz
-	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
-	COMMENT "Creating Debian package" VERBATIM
-	)
+  ln -s libodsstream-${LIBODSSTREAM_VERSION}.tar.gz libodsstream_${LIBODSSTREAM_VERSION}.orig.tar.gz && cd libodsstream-${LIBODSSTREAM_VERSION} && dpkg-buildpackage -sa
+  DEPENDS targz
+  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+  COMMENT "Creating Debian package" VERBATIM
+)
 
 add_custom_target(lintian
-	lintian -IEi --pedantic ${changesdeb}
-	DEPENDS deb
-	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
-	COMMENT "lintian check" VERBATIM
-	)
+  lintian -IEi --pedantic ${changesdeb}
+  DEPENDS deb
+  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+  COMMENT "lintian check" VERBATIM
+)
 
 if(MAKE_TEST)
-	enable_testing()
-	include(CTest)
-	if(BUILD_TESTING)
-		add_subdirectory(test)
-	endif(BUILD_TESTING)
+  enable_testing()
+  include(CTest)
+  if(BUILD_TESTING)
+    add_subdirectory(test)
+  endif(BUILD_TESTING)
 endif(MAKE_TEST)
 
 
-# message(STATUS CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH})
+message(STATUS CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH})
 
 # Install cmake module
-install(FILES ${CMAKE_MODULE_PATH}/FindOdsStream.cmake DESTINATION share/cmake/Modules)
+install(FILES ${CMAKE_UTILS_PATH}/modules/FindOdsStream.cmake DESTINATION lib${LIB_SUFFIX}/cmake/odsstream)
 # Install cmake config
-configure_file (${CMAKE_MODULE_PATH}/OdsStreamConfig.cmake ${CMAKE_SOURCE_DIR}/OdsStreamConfig.cmake)
-install(FILES ${CMAKE_SOURCE_DIR}/OdsStreamConfig.cmake DESTINATION lib${LIB_SUFFIX}/cmake/odsstream)
-#configure_file (${CMAKE_SOURCE_DIR}/debian/rules.cmake ${CMAKE_SOURCE_DIR}/debian/rules @ONLY)
+
+# Older version
+#configure_file (${CMAKE_UTILS_PATH}/modules/OdsStreamConfig.cmake.in ${CMAKE_SOURCE_DIR}/OdsStreamConfig.cmake)
+#install(FILES ${CMAKE_SOURCE_DIR}/OdsStreamConfig.cmake DESTINATION lib${LIB_SUFFIX}/cmake/odsstream)
+
+# More modern CMake version
+
+install(EXPORT OdsStreamTargets
+  FILE OdsStreamTargets.cmake
+  NAMESPACE OdsStream::
+  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/odsstream)
+
+include(CMakePackageConfigHelpers)
+
+configure_package_config_file(${CMAKE_SOURCE_DIR}/CMakeStuff/modules/OdsStreamConfig.cmake.in
+  "${CMAKE_CURRENT_BINARY_DIR}/OdsStreamConfig.cmake"
+  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/odsstream)
+
+install(FILES
+  "${CMAKE_CURRENT_BINARY_DIR}/OdsStreamConfig.cmake"
+  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/odsstream)
+
+
+

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -8,24 +8,24 @@
 configure_file (config.h.cmake ${CMAKE_SOURCE_DIR}/test/config.h)
 
 
-find_package(Qt5 COMPONENTS Core Xml Gui REQUIRED)
+find_package(Qt6 COMPONENTS Core Xml Gui REQUIRED)
 
 find_package(Catch2 REQUIRED)
 
 include_directories(${QUAZIP_INCLUDE_DIR} "${CMAKE_SOURCE_DIR}/src")
 
 add_executable(test_ods test_ods.cpp)
-target_link_libraries(test_ods Catch2::Catch2 Qt5::Core Qt5::Gui ${QUAZIP_LIBRARIES} odsstream-shared)
+target_link_libraries(test_ods Catch2::Catch2 Qt6::Core Qt6::Gui QuaZip::QuaZip Core)
 add_test(test_ods "test_ods")
 
 
 add_executable(test_tsv test_tsv.cpp)
-target_link_libraries(test_tsv Qt5::Core Qt5::Gui odsstream-shared ${QUAZIP_LIBRARIES})
+target_link_libraries(test_tsv Qt6::Core Qt6::Gui Core QuaZip::QuaZip)
 add_test(test_tsv "test_tsv")
 
 
 add_executable(test_zlib test_zlib.cpp)
-target_link_libraries(test_zlib Qt5::Core odsstream-shared ${QUAZIP_LIBRARIES})
+target_link_libraries(test_zlib Qt6::Core Core QuaZip::QuaZip)
 add_test(test_zlib "test_zlib")

=== debian/changelog ===
libodsstream (0.9.1-2) unstable; urgency=medium

  * Team upload.
  * Fix Homepage
  * Add watch file
  * Standards-Version: 4.6.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Trim trailing whitespace.
  * Simplify installation of libodsstream.so
  * Close bug that should have been closed in previous paragraph
    Closes: #1026044

 -- Andreas Tille <tille@debian.org>  Thu, 22 Dec 2022 09:34:19 +0100

libodsstream (0.9.1-1) unstable; urgency=low

  * Rework the CMake-based Config.cmake generation process to stick to more
    modern approaches.

  * Add libquazip1-qt6-dev and other development packages as
    libodsstream-dev's dependency.

  * dh_auto_test added in d/rules.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 13 Dec 2022 22:48:47 +0100

libodsstream (0.9.0-2) UNRELEASED; urgency=medium

  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on dh-exec.

 -- Debian Janitor <janitor@jelmer.uk>  Wed, 02 Nov 2022 08:50:29 -0000

libodsstream (0.9.0-1) unstable; urgency=low

  * Port of the project to Qt6.

  * Standards-Version: 4.6.1 (routine update).

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 13 Sep 2022 21:09:28 +0200

libodsstream (0.8.5-1~bullseye+1) bullseye; urgency=medium

  * bullseye backport

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 31 Oct 2022 09:10:37 +0100

libodsstream (0.8.5-1) unstable; urgency=low

  * New version to fix distribution.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 28 Oct 2022 03:52:21 +0200

libodsstream (0.8.4-1) bullseye; urgency=low

  * New upstream version.

  * Standards-Version: 4.6.1 (routine update)

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 28 Oct 2022 02:26:21 +0200

libodsstream (0.8.3-1~bullseye+1) bullseye; urgency=medium

  * bug fix on ZipTsvOutputStream

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 05 Oct 2022 10:38:55 +0200

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,20 @@
 Uploaders: Filippo Rusconi <lopippo@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat(= 12),
- dh-exec (>= 0.3),
+Build-Depends: debhelper-compat (= 13),
+ dh-exec,
  cmake,
  d-shlibs,
- libquazip5-dev,
- qtbase5-dev,
+ qt6-base-dev,
+ libqt6core5compat6-dev,
+ zlib1g-dev,
+ libquazip1-qt6-dev,
  doxygen,
  catch2
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debichem-team/libodsstream
 Vcs-Git: https://salsa.debian.org/debichem-team/libodsstream.git
-Homepage: http://pappso.inrae.fr/bioinfo
+Homepage: https://forgemia.inra.fr/pappso/libodsstream
 Rules-Requires-Root: no
 
 Package: libodsstream0
@@ -37,8 +39,11 @@
 Multi-Arch: same
 Section: libdevel
 Depends: libodsstream0 (= ${binary:Version}),
-         ${misc:Depends},
-         libquazip5-dev
+ ${misc:Depends},
+ qt6-base-dev,
+ libqt6core5compat6-dev,
+ zlib1g-dev,
+ libquazip1-qt6-dev,
 Breaks: libodsstream-qt5-dev (<< 0.7.9-1~)
 Replaces: libodsstream-qt5-dev (<< 0.7.9-1~)
 Description: C++ library to read or write ODS files (development files)
@@ -53,6 +58,7 @@
 Architecture: all
 Section: doc
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: doxygen documentation of the ODSstream library
  libodsstream provides a simple way to read and write Open
  Document Spreadsheet files. The hight memory efficiency comes

=== debian/rules ===
--- 
+++ 
@@ -37,3 +37,4 @@
 override_dh_auto_build:
 	dh_auto_build --no-parallel
 	dh_auto_build -- doc
+	dh_auto_test

=== debian/watch ===
version=4

https://forgemia.inra.fr/pappso/libodsstream/-/tags .*/libodsstream-master-(\d[.\d]*)-1\.tar\.gz

## libodsstream 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,10 +14,10 @@
 
 set(LIBODSSTREAM_VERSION_MAJOR "0")
 set(LIBODSSTREAM_VERSION_MINOR "9")
-set(LIBODSSTREAM_VERSION_PATCH "1")
+set(LIBODSSTREAM_VERSION_PATCH "2")
 set(LIBODSSTREAM_LIB_NAME "libodsstream")
 set(LIBODSSTREAM_VERSION "${LIBODSSTREAM_VERSION_MAJOR}.${LIBODSSTREAM_VERSION_MINOR}.${LIBODSSTREAM_VERSION_PATCH}")
-set(VERSION 0.9.1)
+set(VERSION 0.9.2)
 set(LIBODSSTREAM_LIB_VERSION ${LIBODSSTREAM_VERSION})
 set(LIBODSSTREAM_LIB_SOVERSION ${LIBODSSTREAM_VERSION_MAJOR})
